POJ 2299 Ultra-QuickSort(树状数组 + 离散)

链接:http://poj.org/problem?id=2299

题意:给出N个数组成的数列A(0 <= A[i] <= 999,999,999),求该数列逆序对的数量。

分析:题目所谓的排序过程其实就是一个冒泡排序的过程。在这里,我们需要知道,冒泡排序所需交换的次数等于该序列逆序对的数量(证明略)。这是这道题的一个切入点。

   树状数组可以很方便地求出数列的前缀和,对于一个数x,我们使树状数组上第x个元素的值赋为1,这时调用Sum(x)就可以得到一个从第1项到第x项的前缀和。这意味着我们可以通过这种方法来知道到目前为止出现了多少个比x小的数(其个数即为Sum(x))。由于题目对排序的要求是升序,因此我们真正要找的其实是到目前为止出现了多少个比x大的数,所以逆序对的个数应为【当前插入到树状数组中的元素个数】 - Sum(x)。因此,树状数组可以很好的解决我们现在这个问题。

   从上面我们得知,我们是通过树状数组来得到前x项和进而求得我们所要得结果的。但是本题的x范围太大,运行环境不允许开这么大的数组。从题面得知输入的数不超过500000,遇到这种局面,不难想到要使用离散化去减轻空间上的负担。

   事实上,数列上的数值本身其实对我们是没有用的。因为我们要求的是逆序对,真正对我们有价值的是数与数之间的大小关系,我们额外保存数列中元素的位置后,对数列进行一次排序,便可将原数列的元素映射在1 ~ N(N为该数列的大小,N <= 500000)的区间里。这时我们再使用上述方法去求得逆序对的个数,就可以解决这个问题了。

 1 #include <cstdio>
 2 #include <cstring>
 3 #include <algorithm>
 4
 5 using namespace std;
 6
 7 const int MAXN = 500010;
 8
 9 struct Node {
10     int val,id;
11
12     bool operator < (const Node &p) const {
13         return val < p.val;
14     }
15 }num[MAXN];
16
17 int n;
18 int disp_num[MAXN];
19 int tree[MAXN];
20
21 int lowbit(int x) {
22     return (x) & (-x);
23 }
24
25 void update(int i,int val) {
26     while (i <= n) {
27         tree[i] += val;
28         i += lowbit(i);
29     }
30 }
31
32 long long getSum(int i) {
33     long long ans = 0;
34     while (i > 0) {
35         ans += tree[i];
36         i -= lowbit(i);
37     }
38     return ans;
39 }
40
41 int main() {
42     while (scanf("%d",&n),n) {
43         for (int i=1;i<=n;i++) {
44             scanf("%d",&num[i].val);
45             num[i].id = i;
46         }
47         sort(num+1,num+n+1);
48         for (int i=1;i<=n;i++) {
49             disp_num[num[i].id] = i;
50         }
51         long long ans = 0;
52         memset(tree,0,sizeof(tree));
53         for (int i=1;i<=n;i++) {
54             update(disp_num[i],1);
55             ans += i-getSum(disp_num[i]);
56         }
57         printf("%lld\n",ans);
58     }
59
60     return 0;
61 }

   

   

原文地址:https://www.cnblogs.com/doublebit/p/10836072.html

时间: 2024-11-10 09:38:33

POJ 2299 Ultra-QuickSort(树状数组 + 离散)的相关文章

POJ 2299 Ultra-QuickSort(树状数组+离散化)

http://poj.org/problem?id=2299 题意:给出一组数,求逆序对. 思路: 这道题可以用树状数组解决,但是在此之前,需要对数据进行一下预处理. 这道题目的数据可以大到999,999,999,但数组肯定是无法开这么大的,但是每组数据最多只有500000个,那么,怎么办呢,离散化! 离散化,也就是将数据和1~n做一一映射. 比如: 9 1 0 5 4 离散化之后变成 5 2 1 4 3 这样的话,就可以放心的开数组啦! 至于树状数组的计算过程,我懒得写了,直接摘抄一下大神的h

poj 2299 Ultra-QuickSort 离散化 + 树状数组

题目链接:http://poj.org/problem?id=2299 离散化 + 树状数组 教科书例题般的题目 #include <iostream> #include <cstdio> #include <cstring> #include <queue> #include <cmath> #include <vector> #include <stack> #include <set> #include

poj 2299 Ultra-QuickSort (树状数组+离散化)

Ultra-QuickSort Time Limit: 7000MS   Memory Limit: 65536K Total Submissions: 48257   Accepted: 17610 Description In this problem, you have to analyze a particular sorting algorithm. The algorithm processes a sequence of n distinct integers by swappin

poj 2299 Ultra-QuickSort(树状数组求逆序数+离散化)

题目链接:http://poj.org/problem?id=2299 Description In this problem, you have to analyze a particular sorting algorithm. The algorithm processes a sequence of n distinct integers by swapping two adjacent sequence elements until the sequence is sorted in

POJ 2299 Ultra-QuickSort (树状数组)

前段时间用归并排序写了这题,发现树状数组也能解这题,就去学习了一下 首先先来看一个序列   6 1 2 7 3 4 8 5,此序列的逆序数为5+3+1=9.冒泡法可以直接枚举出逆序数,但是时间复杂度太高O(n^2).冒泡排序的原理是枚举每一个数组,然后找出这个数后面有多少个数是小于这个数的,小于它逆序数+1.仔细想一下,如果我们不用枚举这个数后面的所有数,而是直接得到小于这个数的个数,那么效率将会大大提高. 总共有N个数,如何判断第i+1个数到最后一个数之间有多少个数小于第i个数呢?不妨假设有一

Poj 2299 - Ultra-QuickSort 离散化,树状数组,逆序对

Ultra-QuickSort Time Limit: 7000MS   Memory Limit: 65536K Total Submissions: 52306   Accepted: 19194 Description In this problem, you have to analyze a particular sorting algorithm. The algorithm processes a sequence of n distinct integers by swappin

POJ 2299 Ultra-QuickSort(树状数组)

Ultra-QuickSort Time Limit: 7000MS   Memory Limit: 65536K Total Submissions: 47014   Accepted: 17182 Description In this problem, you have to analyze a particular sorting algorithm. The algorithm processes a sequence of n distinct integers by swappin

poj 2299 Ultra-QuickSort(树状数组 / 求逆序数)

Ultra-QuickSort Time Limit: 7000MS   Memory Limit: 65536K Total Submissions: 46080   Accepted: 16763 Description In this problem, you have to analyze a particular sorting algorithm. The algorithm processes a sequence of n distinct integers by swappin

hdu 1541/poj 2352:Stars(树状数组,经典题)

Stars Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 4052    Accepted Submission(s): 1592 Problem Description Astronomers often examine star maps where stars are represented by points on a plan

POJ 2892 Tunnel Warfare (树状数组+二分)

题目大意: 三个操作 D pos  将pos位置摧毁,让它和周围不相连. Q pos 问和pos 相连的有多少个村庄. R 修复最近摧毁的村庄. 思路分析: 树状数组记录这个区间有多少个1. 如果  [s-e] 有e-s+1个1 的话.那么这个区间是相连的. 这样的话,我们就可以用二分的办法求出与某个位置最大相连的数量. 还有这里二分 while(l<=r) { if(满足) { ans=mid; l=mid+1; } else r=mid-1; } #include <cstdio>